pub(crate) mod font;

mod config;
pub(crate) use config::AmadeusConfig;
pub(crate) use config::AmadeusMainView;

mod int_text_buffer;
pub(crate) use int_text_buffer::IntegerTextBuffer;
pub(crate) type NetworkPort = IntegerTextBuffer<u16>;

pub(crate) fn get_icon_as_dynamic_image() -> (image::RgbaImage, [u32; 2]) {
    static LOGO_SIDE: u32 = 48u32;
    let logo_data = image::load_from_memory(include_bytes!("../../../rsc/AmadeusLogo.jpg"))
        .expect("Failed to load Amadeus Logo")
        .thumbnail(LOGO_SIDE, LOGO_SIDE);
    let size = [logo_data.width(), logo_data.height()];
    let logo_buffer = logo_data.to_rgba8();
    (logo_buffer, size)
}

pub(crate) fn get_icon_data() -> eframe::IconData {
    let (logo_buffer, [size_x, size_y]) = get_icon_as_dynamic_image();
    eframe::IconData {
        rgba: logo_buffer.to_vec(),
        height: size_y,
        width: size_x,
    }
}
